

energy_per_shot=1000 --constant related to amount of energy used in a single shot
check_interval=30 --interval between checks of players

--temporary workaround, every bullet type should be listed here, to provide interchangeability
--of items in same category
ammo_category={--cannot get ammocategory from anywhere
	['firearm-magazine']='bullet',
	['piercing-rounds-magazine']='bullet',
}
category_ammo={}
for k,v in pairs(ammo_category) do
	category_ammo[v]=category_ammo[v] or {}
	table.insert(category_ammo[v],k)
end

function init()
	--creation of information tables about generated entities
	global.equip_data={--[[
		[equipment_name]={
			ammo=ammo_name,
			magazine_size=int,
		}
	]]}
	global.ammo_equip={--[[
		[ammo_name]=equipment_name
	]]}
	for k,v in pairs(game.item_prototypes) do
		if string.find(k,"automated%-equipment%-#") then
		--equipment is named as 'automated-equipment-#' ..ammo.name.. '#'
			local ammo
			_,_,ammo=string.find(k,"#(.+)#")
			global.equip_data[k]={
				ammo=ammo,
				magazine_size=game.item_prototypes[ammo].magazine_size,
				}
			global.ammo_equip[ammo]=k
		end
	end
	--value for ontick counter
	global.next=1
	--global table to store all the characters that should be updated
	global.characters={
	--[[
		[player_index]={
			inventory=inventory_reference,
			self=character_reference,
			grid=reference_of_armor_grid,
			{
				[1]=equipment_reference,
				[2]=energy,
				[3]=name,
			},
		}
	]]
	}
end
script.on_init(function() init() end)
script.on_configuration_changed(function() init() end)

function armor_check(event)--armor inventory is changed, see if there's powerarmor with bullet equipment
	local p=game.players[event.player_index]
	if not (p.valid and p.character) then return end
	local ch=p.character
	local armor=ch.get_inventory(defines.inventory.player_armor)[1]
	local found={}
	if armor and armor.valid_for_read  and armor.has_grid then--character is wearing powerarmor
		local grid=armor.grid
		--search for relevant equipment in grid
		local equips=global.equip_data
		for _,e in pairs(grid.equipment) do 
			if equips[e.name] then
				table.insert(found,{e,e.energy,e.name})--make note of the equipment
			end
		end
		if #found>0 then
			found.self=ch
			found.grid=armor.grid
			found.inventory=ch.get_inventory(defines.inventory.player_main)
		end
	end
	--see if spare ammo should be returned
	local previous=global.characters[ch.unit_number]
	local energy_per_shot=energy_per_shot
	if previous then
		local inv=previous.inventory
		local equips=global.equip_data
		for i=1,#previous do--check whether equipment is still in grid
			local e=previous[i]
			local eq=equips[e[3]]
			local menergy = eq.magazine_size*energy_per_shot
			if not e[1].valid then--if not return ammo
				local count=(e[2]/menergy)
				if count~=0 then
					count=math.floor(count)
					if count~=0 then
						inv.insert{name=eq.ammo,count=count}
					else
						inv.insert{name=eq.ammo,count=1, ammo=e[2]%menergy}
					end
				end
			end
		end
	end
	global.characters[ch.unit_number]= #found>0 and found or nil
end
script.on_event({
	defines.events.on_player_armor_inventory_changed,
	defines.events.on_player_placed_equipment,
	defines.events.on_player_removed_equipment},
armor_check)

function update()
	local int=check_interval
	if global.next<=#global.characters then 
		local chars=global.characters
		local equips=global.equip_data
		local per_shot=energy_per_shot
		for i=global.next,#chars,int do--for each character
			local char=chars[i]
			--if char.self.valid and (char.armor_inventory[1]==char.armor) then
			if char.self.valid  then
				local inv=char.inventory
				for j=1,#char do--for each relevant equip on the character
					local e=char[j][1]
					local eq=equips[e.name]
					local menergy = eq.magazine_size*per_shot
					if e.max_energy-e.energy> menergy then--see if reload is required
						if inv.get_item_count(eq.ammo)>10 then--is there ammo
							inv.remove{name=eq.ammo,count=1}
							e.energy=e.energy+ menergy
							
						elseif e.energy<per_shot then--or is ammo critically low
							--is there other ammo of same category
							for _,ammo in pairs(category_ammo[ammo_category[eq.ammo]]) do
								if inv.get_item_count(ammo)>10 then
									--swap to equivalent equipment
									local grid=char.grid
									local pos=e.position
									grid.take{equipment=e}
									e=grid.put{name=global.ammo_equip[ammo],position=pos}
									char[j][1]=e
									char[j][3]=e.name
									inv.remove{name=ammo,count=1}
									e.energy=e.energy+ equips[e.name].magazine_size*per_shot
									break
								end
							end
						end
					end
					char[j][2]=e.energy
				end
			end
		end
	end
	global.next= (global.next % int) +1
end
script.on_event(defines.events.on_tick, update)

script.on_event(defines.events.on_player_created,function(e)
	local p=game.players[e.player_index]
	p.insert{name= 'automated-equipment-#' ..'firearm-magazine'.. '#',count=1}
	p.insert('power-armor')
	p.insert("fusion-reactor-equipment")
	p.insert('piercing-rounds-magazine')
end)
